"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.saveConfig = exports.removeOnStateChangeListener = exports.prepare = exports.onStateChangedListener = exports.getCurrentState = exports.getConnectionTimeSecond = exports.getCharonErrorState = exports.disconnect = exports.default = exports.connect = exports.VpnState = exports.STATE_CHANGED_EVENT_NAME = exports.CharonErrorState = void 0;
var _reactNative = require("react-native");
var VpnState;
exports.VpnState = VpnState;
(function (VpnState) {
  if (_reactNative.Platform.OS == 'ios') {
    VpnState[VpnState['invalid'] = 0] = 'invalid';
    VpnState[VpnState['disconnected'] = 1] = 'disconnected';
    VpnState[VpnState['connecting'] = 2] = 'connecting';
    VpnState[VpnState['connected'] = 3] = 'connected';
    VpnState[VpnState['reasserting'] = 4] = 'genericError';
    VpnState[VpnState['disconnecting'] = 5] = 'disconnecting';
  } else {
    //     disconnected,
    // connecting,
    // connected,
    // disconnecting,
    // genericError,
    VpnState[VpnState['disconnected'] = 0] = 'disconnected';
    VpnState[VpnState['connecting'] = 1] = 'connecting';
    VpnState[VpnState['connected'] = 2] = 'connected';
    VpnState[VpnState['disconnecting'] = 3] = 'disconnecting';
    VpnState[VpnState['genericError'] = 4] = 'genericError';
    VpnState[VpnState['invalid'] = 5] = 'invalid';
  }
})(VpnState || (exports.VpnState = VpnState = {}));
var CharonErrorState;
exports.CharonErrorState = CharonErrorState;
(function (CharonErrorState) {
  CharonErrorState[CharonErrorState['NO_ERROR'] = 0] = 'NO_ERROR';
  CharonErrorState[CharonErrorState['AUTH_FAILED'] = 1] = 'AUTH_FAILED';
  CharonErrorState[CharonErrorState['PEER_AUTH_FAILED'] = 2] = 'PEER_AUTH_FAILED';
  CharonErrorState[CharonErrorState['LOOKUP_FAILED'] = 3] = 'LOOKUP_FAILED';
  CharonErrorState[CharonErrorState['UNREACHABLE'] = 4] = 'UNREACHABLE';
  CharonErrorState[CharonErrorState['GENERIC_ERROR'] = 5] = 'GENERIC_ERROR';
  CharonErrorState[CharonErrorState['PASSWORD_MISSING'] = 6] = 'PASSWORD_MISSING';
  CharonErrorState[CharonErrorState['CERTIFICATE_UNAVAILABLE'] = 7] = 'CERTIFICATE_UNAVAILABLE';
  CharonErrorState[CharonErrorState['UNDEFINED'] = 8] = 'UNDEFINED';
})(CharonErrorState || (exports.CharonErrorState = CharonErrorState = {}));
const stateChanged = new _reactNative.NativeEventEmitter(_reactNative.NativeModules.RNIpSecVpn);
const STATE_CHANGED_EVENT_NAME = 'stateChanged';
exports.STATE_CHANGED_EVENT_NAME = STATE_CHANGED_EVENT_NAME;
const removeOnStateChangeListener = stateChangedEvent => {
  stateChangedEvent.remove();
};
exports.removeOnStateChangeListener = removeOnStateChangeListener;
const onStateChangedListener = callback => {
  return stateChanged.addListener(STATE_CHANGED_EVENT_NAME, e => callback(e));
};
exports.onStateChangedListener = onStateChangedListener;
const prepare = _reactNative.NativeModules.RNIpSecVpn.prepare;
exports.prepare = prepare;
const connect = (name, address, username, password, secret, disapleOnSleep) => {
  if (_reactNative.Platform.OS == 'ios') {
    return _reactNative.NativeModules.RNIpSecVpn.connect(name, address || '', username || '', password || '', secret || '', disapleOnSleep);
  } else {
    return _reactNative.NativeModules.RNIpSecVpn.connect(address || '', username || '', password || '');
  }
};
exports.connect = connect;
const saveConfig = (name, address, username, password, secret) => {
  if (_reactNative.Platform.OS == 'ios') {
    return _reactNative.NativeModules.RNIpSecVpn.saveConfig(name, address || '', username || '', password || '', secret || '');
  } else {
    return _reactNative.NativeModules.RNIpSecVpn.connect(address || '', username || '', password || '');
  }
};
exports.saveConfig = saveConfig;
const getCurrentState = _reactNative.NativeModules.RNIpSecVpn.getCurrentState;
exports.getCurrentState = getCurrentState;
const getConnectionTimeSecond = _reactNative.NativeModules.RNIpSecVpn.getConnectionTimeSecond;
exports.getConnectionTimeSecond = getConnectionTimeSecond;
const getCharonErrorState = _reactNative.NativeModules.RNIpSecVpn.getCharonErrorState;
exports.getCharonErrorState = getCharonErrorState;
const disconnect = _reactNative.NativeModules.RNIpSecVpn.disconnect;
exports.disconnect = disconnect;
var _default = _reactNative.NativeModules.RNIpSecVpn;
exports.default = _default;
//# sourceMappingURL=index.js.map